package main

import (
  "fmt"
  "math"
  "math/rand"
  "time"
)

func genStringa() string {
  s := ""
  for i := 0; i < 5; i++ {
    s += string('A' + rand.Intn(6))
  }
  return s
}



/* Data una stringa magic (segreta) e una stringa attempt (il tentativo dell'avversario)
   restituisce quanti sono i caratteri giusti al posto giusto (gpg) e quanti sono giusti
   al posto sbagliato */
func check(magic, attempt string) (gpg int, gps int) {
  // Queste due mappe contano quante volte ogni runa compare nelle due stringhe
  // esclusi i caratteri giusti al posto giusto
  var magicMap, attemptMap map[byte]int
  magicMap = make(map[byte]int)
  attemptMap = make(map[byte]int)
  for i := 0; i < 5; i++ {
    if magic[i] == attempt[i] {
      gpg++
    } else {
      magicMap[magic[i]]++
      attemptMap[attempt[i]]++
    }
  }

  for r, occ := range magicMap {
    gps += int(math.Min(float64(occ), float64(attemptMap[r])))
  }
  return
}

func main() {
  rand.Seed(time.Now().UnixNano())
  magic := genStringa()
  for {
    var attempt string
    fmt.Scan(&attempt)
    gpg, gps := check(magic, attempt)
    fmt.Printf("Giusti al posto giusto: %d\nGiusti al posto sbagliato %d\n", gpg, gps)
    if gpg == 5 {
      break
    }
  }
  fmt.Println("BRAVO!!!! Hai indovinato")
}
